#!/usr/bin/env python
# -*- coding:Utf-8 -*-
# Module rw
# Official Addons
# By Sicilia

import es, playerlib, math

max_rw = es.ServerVar("max_rw")
distance_sup = es.ServerVar("distance_sup")

dico_rw = {}

#################################################
#################### CLASS ######################
#################################################

class Rwg:
    """
        Remove weapon at ground
    """

    def __init__(self, i = 0, d = 0):
        self._dist = {}
        if i: self.__find(i, d)

    def __dist(self, V1, V2):
        return math.sqrt(math.pow(V1[0] - V2[0], 2) + math.pow(V1[1] - V2[1], 2) + math.pow(V1[2] - V2[2], 2))

    def __maxi(self, I, D):
        self._dist[D] = I

    def __find(self, i, d = 0):
        enti = es.createentitylist()
        vect = {}

        for indx in enti:
            if enti[indx]["classname"].startswith("weapon_"):
                if es.getindexprop(indx, "CBaseCombatWeapon.m_hOwner") == -1: vect[indx] = []

        if len(vect):
            for indx in vect:
                map(lambda x: vect[indx].append(float(x)), es.getindexprop(indx, "CBaseEntity.m_vecOrigin").split(","))

            user = es.getplayerlocation(i)
            map(lambda x: self.__maxi(x, self.__dist(user, vect[x])), vect)

            if d == 0: es.server.queuecmd("es_xremove %s" % self._dist[dist])
            else:
                dist = min(self._dist.keys())
                if dist * 0.0254 < float(d): es.server.queuecmd("es_xremove %s" % self._dist[dist])
 
#################################################
#################################################
#################################################
def load():
    es.regclientcmd("!rw", "sici_jail/modules/rw/player_cmd_rw", "remove closest weapon")
    es.regsaycmd("!rw", "sici_jail/modules/rw/player_cmd_rw", "remove closest weapon")
    es.dbgmsg(0, '[Sici Jail] Modules : Rw On')

def round_start(E):
    global dico_rw
    dico_rw.clear()
    
def player_spawn(E):
    if E["es_userteam"] == "3":           
        es.tell(E["userid"], "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultOublie pas pour supprimer une arme à terre : #green!rw")
 
def player_cmd_rw():
    global dico_rw
    userid = es.getcmduserid()
    player = playerlib.getPlayer(userid)
    if player.get("isdead") == 0:    
        team = es.getplayerteam(userid)
        if team == 3:
            if not userid in dico_rw:
                dico_rw[userid] = 0
            if dico_rw[userid] < int(max_rw):
                dico_rw[userid] += 1
                Rwg(userid, distance_sup)
            else:
                es.tell(userid, "#multi", "#lightgreen[#greenSici Jail#lightgreen] #defaultTes #lightgreen'!rw'#default ont déjà été tous utilisés.")
 
def unload():
    es.unregclientcmd("!rw")    
    es.unregsaycmd("!rw")
    es.dbgmsg(0, '[Sici Jail] Modules : Rw Off')    
